/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CLASSECIA                                                */
/* Tabela : CLASSECIA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CLASSECIA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CLASSECIA
GO

CREATE TRIGGER DTULTATU_CLASSECIA
ON CLASSECIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CLASSECIA', CDFILIAL, 'CDFILIAL=' + CDFILIAL+
                                              ';CDCIA='   + CDCIA   +
                                              ';CDCLASSE='+ CDCLASSE+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CLASSECIA
      SET DTULTATUCLAC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CLASSECIA.DSCLASSECIA,0) = ISNULL(INSERTED.DSCLASSECIA,0)) AND
            (ISNULL(CLASSECIA.CDCLASSE,0)    = ISNULL(INSERTED.CDCLASSE,0)) ;
   END;
END;
GO
