import { Metadata } from '@zeedhi/core';
import { ApexChart } from '@zeedhi/common';

export class DashboardController {
    public openNewCall() {
        const data = { command: 'openNewCall' };
        this.sendMessage(data);
    }

    public productDeploy() {
        const data = { command: 'productDeploy' };
        this.sendMessage(data);
    }

    public openCustomizationFiles() {
        const data = { command: 'customizationFiles' };
        this.sendMessage(data);
    }

    public openDownloadVersionCard() {
        const data = { command: 'downloadVersionCard' };
        this.sendMessage(data);
    }

    public budgetChartClick() {
        const data = { command: 'budgetChart' };
        this.sendMessage(data);
    }

    public typeChartClick(event:any, chartContext:any, config:any) {
        const chart = Metadata.getInstance<ApexChart>('pie-type-chart');
        const data = {
            command: 'typeChart',
            type: chart.options.labels[config.dataPointIndex],
        };
        window.parent.postMessage({
            type: 'commandForCp',
            realData: data,
        }, window.location.ancestorOrigins[0]);
    }

    public labelChartClick(event:any, chartContext:any, config:any) {
        const chart = Metadata.getInstance<ApexChart>('pie-label-chart');
        const data = {
            command: 'labelChart',
            label: chart.options.labels[config.dataPointIndex],
        };
        window.parent.postMessage({
            type: 'commandForCp',
            realData: data,
        }, window.location.ancestorOrigins[0]);
    }

    public callNews() {
        const data = { command: 'callNews' };
        this.sendMessage(data);
    }

    public sendMessage(data:Object) {
        window.parent.postMessage({
            type: 'commandForCp',
            realData: data,
        }, window.location.ancestorOrigins[0]);
    }
}
